import java.awt.*;

public class DrawingCaterpillar implements IDrawingCaterpillar {
    private NumRinks numRinks = NumRinks.Four;
    private Color color;

    public DrawingCaterpillar(Color color) {
        this.color = color;
    }
    @Override
    public void setNumRinks(int n) {
        switch (n) {
            case 4 -> numRinks = NumRinks.Four;

            case 5 -> numRinks = NumRinks.Five;

            case 6 -> numRinks = NumRinks.Six;

            default -> {
                break;
            }
        }
    }
    @Override
    public void DrawCaterpillar(Graphics2D g2d, int startPosX, int startPosY)
    {
        color = color != null ? color : Color.YELLOW;
        g2d.setPaint(color);
        int size = numRinks == NumRinks.Four ? 15 : 10;
        int dist = numRinks == NumRinks.Four ? 20 : 13;
        startPosX = numRinks == NumRinks.Five ? startPosX + 5 : startPosX;
        for (int i = 0; i < numRinks.val(); i++) {
            g2d.fillOval(startPosX + dist * i, startPosY + 30, size, size);
        }
    }
}
