import java.awt.*;

public class DrawingDoubleCaterpillar implements IDrawingCaterpillar{
    private NumRinks numRinks = NumRinks.Four;
    private Color color;

    public DrawingDoubleCaterpillar(Color color) {
        this.color = color;
    }

    @Override
    public void setNumRinks(int n) {
        switch (n) {
            case 4 -> numRinks = NumRinks.Four;

            case 5 -> numRinks = NumRinks.Five;

            case 6 -> numRinks = NumRinks.Six;

            default -> {
                break;
            }
        }
    }

    @Override
    public void DrawCaterpillar(Graphics2D g2d, int startPosX, int startPosY) {
        color = color != null ? color : Color.YELLOW;
        int size = numRinks == NumRinks.Four ? 15 : 10;
        int dist = numRinks == NumRinks.Four ? 20 : 13;
        startPosX = numRinks == NumRinks.Five ? startPosX + 5 : startPosX;
        for (int i = 0; i < numRinks.val(); i++) {
            g2d.setPaint(color);
            g2d.fillOval(startPosX + dist * i, startPosY + 30, size, size);
            g2d.setPaint(Color.WHITE);
            g2d.fillOval(startPosX + dist * i + size/4, startPosY + 30 + size/4, size/2, size/2);
        }
    }
}
