import java.util.Random;

public class GenericEntityArmoredCar<T extends EntityArmoredCar, U extends IDrawingCaterpillar> {
    private T[] armoredCars;
    private int carsCount = 0;
    private U[] caterpillars;
    private int caterpillarsCount = 0;

    public GenericEntityArmoredCar(int numberObjects) {
        this.armoredCars = (T[]) new EntityArmoredCar[numberObjects];
        this.caterpillars = (U[]) new IDrawingCaterpillar[numberObjects];
    }

    public void Insert(T armoredCar)
    {
        if (carsCount >= armoredCars.length)
            return;
        armoredCars[carsCount++] = armoredCar;
    }

    public void Insert(U caterpillar)
    {
        if (caterpillarsCount >= caterpillars.length)
            return;
        caterpillars[caterpillarsCount++] = caterpillar;
    }

    public DrawingArmoredCar getDrawingObject() {
        Random r = new Random();
        EntityArmoredCar armoredCar = armoredCars[r.nextInt(carsCount)];
        IDrawingCaterpillar caterpillar = caterpillars[r.nextInt(caterpillarsCount)];
        DrawingArmoredCar o = new DrawingArmoredCar(armoredCar.getSpeed(), armoredCar.getWeight(), armoredCar.getBodyColor());
        o.SetCaterpillar(caterpillar);
        return o;
    }
}
